ServerEvents.recipes(event => {
  const AA = id => `ad_astra:${id}`
  const NC = id => `nuclearcraft:${id}`
  const SC = id => `scguns:${id}`

  event.shaped('minecraft:end_portal_frame', [
    'CGC',
    'BNB',
    'FTF'
  ], {
    C: AA('calorite_block'),          // endgame Ad Astra metal
    G: AA('permafrost'),            // Glacio tier

    // Middle: late-game core
    B: 'minecraft:sculk',       // sculk because fuck you thats why
    N: SC('nether_star_fragment'),    // Nether progression

    // Bottom: infernal + sky
    T: NC('thorium_block'),           // NuclearCraft late-game
    F: SC('plasma_block')                // late game scorched guns
  }).id('atomized:end_portal_frame/glhf')
})